---- Cut Here and feed the following to sh ----
#!/bin/sh
# This is a shell archive (produced by shar 3.49)
# To extract the files from this archive, save it to a file, remove
# everything above the "!/bin/sh" line above, and type "sh file_name".
#
# made 04/05/1991 22:21 UTC by mleisher@nmsu.edu
# Source directory /tmp_mnt/home/nikita2/X11R4/contrib/fonts/bdftools/headers
#
# existing files will NOT be overwritten unless -c is specified
#
# This shar contains:
# length  mode       name
# ------ ---------- ------------------------------------------
#   4329 -rw-rw-r-- bdftosnf.h
#   3166 -rw-rw-r-- font.h
#   3784 -rw-rw-r-- fontstruct.h
#   4542 -rw-rw-r-- misc.h
#   3804 -rw-rw-r-- os.h
#   8984 -rw-rw-r-- servermd.h
#   3296 -rw-rw-r-- snfstruct.h
#
# ============= bdftosnf.h ==============
if test -f 'bdftosnf.h' -a X"$1" != X"-c"; then
	echo 'x - skipping bdftosnf.h (File already exists)'
else
echo 'x - extracting bdftosnf.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'bdftosnf.h' &&
#ifdef SYSV
#include <memory.h>
#define bzero(b,length) memset(b,0,length)
/* these are not strictly equivalent, but suffice for uses here */
#define bcopy(b1,b2,length) memcpy(b2,b1,length)
#endif /* SYSV */
X
#ifndef MIN
#define MIN(a,b) ((a)>(b)?(b):(a))
#endif
#ifndef MAX
#define MAX(a,b) ((a)>(b)?(a):(b))
#endif
X
typedef struct _GlyphMap {
X    char	*bits;
X    int		h;
X    int		w;
X    int		widthBytes;
} GlyphMap;
X
/*
X * a structure to hold all the pointers to make it easy to pass them all
X * around. Much like the FONT structure in the server.
X */
X
typedef struct _TempFont {
X    FontInfoPtr pFI;
X    CharInfoPtr pCI;
X    unsigned char *pGlyphs;
X    FontPropPtr pFP;
X    CharInfoPtr pInkCI;
X    CharInfoPtr pInkMin;
X    CharInfoPtr pInkMax;
} TempFont; /* not called font since collides with type in X.h */
X
#ifdef vax
X
#	define DEFAULTGLPAD 	1		/* default padding for glyphs */
#	define DEFAULTBITORDER 	LSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER LSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
#else
# ifdef sun
X
#  if (sun386 || sun5)
#	define DEFAULTGLPAD 	4		/* default padding for glyphs */
#	define DEFAULTBITORDER 	LSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER LSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
#  else
#	define DEFAULTGLPAD 	4		/* default padding for glyphs */
#	define DEFAULTBITORDER 	MSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
#  endif
X
# else
#  ifdef apollo
X
#	define DEFAULTGLPAD 	2		/* default padding for glyphs */
#	define DEFAULTBITORDER 	MSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#  else
#   ifdef ibm032
X
#	define DEFAULTGLPAD 	1		/* default padding for glyphs */
#	define DEFAULTBITORDER 	MSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#   else
#    ifdef hpux
X
#	define DEFAULTGLPAD 	2		/* default padding for glyphs */
#	define DEFAULTBITORDER 	MSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#    else
#     ifdef pegasus
X
#	define DEFAULTGLPAD 	4		/* default padding for glyphs */
#	define DEFAULTBITORDER 	MSBFirst	/* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#     else
#      ifdef macII
X
#       define DEFAULTGLPAD     4               /* default padding for glyphs */
#       define DEFAULTBITORDER  MSBFirst        /* default bitmap bit order */
#	define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#      else
#       ifdef mips
#        ifdef MIPSEL
X
#	  define DEFAULTGLPAD 	  4		/* default padding for glyphs */
#	  define DEFAULTBITORDER  LSBFirst	/* default bitmap bit order */
#	  define DEFAULTBYTEORDER LSBFirst	/* default bitmap byte order */
#	  define DEFAULTSCANUNIT  1		/* default bitmap scan unit */
X
#        else
#	  define DEFAULTGLPAD 	  4		/* default padding for glyphs */
#	  define DEFAULTBITORDER  MSBFirst	/* default bitmap bit order */
#	  define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	  define DEFAULTSCANUNIT  1		/* default bitmap scan unit */
#        endif
#       else
X
#	 define DEFAULTGLPAD 	1		/* default padding for glyphs */
#	 define DEFAULTBITORDER MSBFirst	/* default bitmap bit order */
#	 define DEFAULTBYTEORDER MSBFirst	/* default bitmap byte order */
#	 define DEFAULTSCANUNIT	1		/* default bitmap scan unit */
X
#       endif
#      endif
#     endif
#    endif
#   endif
#  endif
# endif
#endif
X
#define GLWIDTHBYTESPADDED(bits,nbytes) \
X	((nbytes) == 1 ? (((bits)+7)>>3)	/* pad to 1 byte */ \
X	:(nbytes) == 2 ? ((((bits)+15)>>3)&~1)	/* pad to 2 bytes */ \
X	:(nbytes) == 4 ? ((((bits)+31)>>3)&~3)	/* pad to 4 bytes */ \
X	:(nbytes) == 8 ? ((((bits)+63)>>3)&~7)	/* pad to 8 bytes */ \
X	: 0)
X
SHAR_EOF
chmod 0664 bdftosnf.h ||
echo 'restore of bdftosnf.h failed'
Wc_c="`wc -c < 'bdftosnf.h'`"
test 4329 -eq "$Wc_c" ||
	echo 'bdftosnf.h: original size 4329, current size' "$Wc_c"
fi
# ============= font.h ==============
if test -f 'font.h' -a X"$1" != X"-c"; then
	echo 'x - skipping font.h (File already exists)'
else
echo 'x - extracting font.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'font.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
#ifndef FONT_H
#define FONT_H 1
X
#include "servermd.h"
X
#define NullCharInfo ((CharInfoPtr)0)
#define NullFontInfo ((FontInfoPtr)0)
#define LeftToRight 0
#define RightToLeft 1
/*
X * for linear char sets
X */
#define n1dChars(pfi) ((pfi)->lastCol - (pfi)->firstCol + 1)
#define chFirst firstCol	/* usage:  pfi->chFirst */
#define chLast lastCol		/* usage:  pfi->chLast */
X
/*
X * for 2D char sets
X */
#define n2dChars(pfi)	(((pfi)->lastCol - (pfi)->firstCol + 1) * \
X			 ((pfi)->lastRow - (pfi)->firstRow + 1))
X
#define ADDRXTHISCHARINFO( pf, ch ) \
X        ((CharInfoRec *) &((pf)->pCI[(ch) - (pf)->pFI->chFirst]))
X
#define	GLWIDTHPIXELS(pci) \
X	((pci)->metrics.rightSideBearing - (pci)->metrics.leftSideBearing)
#define	GLHEIGHTPIXELS(pci) \
X 	((pci)->metrics.ascent + (pci)->metrics.descent)
X
X
#define	GLYPHWIDTHBYTES(pci)	(((GLYPHWIDTHPIXELS(pci))+7) >> 3)
#define	GLYPHHEIGHTPIXELS(pci)	(pci->metrics.ascent + pci->metrics.descent)
#define	GLYPHWIDTHPIXELS(pci)	(pci->metrics.rightSideBearing \
X				    - pci->metrics.leftSideBearing)
#define GLWIDTHPADDED( bc)	((bc+7) & ~0x7)
X
#if GLYPHPADBYTES == 0 || GLYPHPADBYTES == 1
#define	GLYPHWIDTHBYTESPADDED(pci)	(GLYPHWIDTHBYTES(pci))
#define	PADGLYPHWIDTHBYTES(w)		(((w)+7)>>3)
#endif
X
#if GLYPHPADBYTES == 2
#define	GLYPHWIDTHBYTESPADDED(pci)	((GLYPHWIDTHBYTES(pci)+1) & ~0x1)
#define	PADGLYPHWIDTHBYTES(w)		(((((w)+7)>>3)+1) & ~0x1)
#endif
X
#if GLYPHPADBYTES == 4
#define	GLYPHWIDTHBYTESPADDED(pci)	((GLYPHWIDTHBYTES(pci)+3) & ~0x3)
#define	PADGLYPHWIDTHBYTES(w)		(((((w)+7)>>3)+3) & ~0x3)
#endif
X
#if GLYPHPADBYTES == 8 /* for a cray? */
#define	GLYPHWIDTHBYTESPADDED(pci)	((GLYPHWIDTHBYTES(pci)+7) & ~0x7)
#define	PADGLYPHWIDTHBYTES(w)		(((((w)+7)>>3)+7) & ~0x7)
#endif
X
typedef struct _FontProp *FontPropPtr;
typedef struct _CharInfo *CharInfoPtr;
typedef struct _FontInfo *FontInfoPtr;
typedef unsigned int DrawDirection;
typedef struct _ExtentInfo *ExtentInfoPtr;
X
X
#endif /* FONT_H */
SHAR_EOF
chmod 0664 font.h ||
echo 'restore of font.h failed'
Wc_c="`wc -c < 'font.h'`"
test 3166 -eq "$Wc_c" ||
	echo 'font.h: original size 3166, current size' "$Wc_c"
fi
# ============= fontstruct.h ==============
if test -f 'fontstruct.h' -a X"$1" != X"-c"; then
	echo 'x - skipping fontstruct.h (File already exists)'
else
echo 'x - extracting fontstruct.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'fontstruct.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
#ifndef FONTSTRUCT_H
#define FONTSTRUCT_H 1
#include "font.h"
#include "misc.h"
X
typedef struct _CharInfo {
X    xCharInfo	metrics;	/* info preformatted for Queries */
X    unsigned	byteOffset:24;	/* byte offset of the raster from pGlyphs */
X    Bool	exists:1;	/* true iff glyph exists for this char */
X    unsigned	pad:7;		/* must be zero for now */
} CharInfoRec;
X
typedef struct _FontInfo {
X    unsigned int	version1;   /* version stamp */
X    unsigned int	allExist;
X    unsigned int	drawDirection;
X    unsigned int	noOverlap;	/* true if:
X					 * max(rightSideBearing-characterWidth)
X					 * <= minbounds->metrics.leftSideBearing
X					 */
X    unsigned int	constantMetrics;
X    unsigned int	terminalFont;	/* Should be deprecated!  true if:
X					   constant metrics &&
X					   leftSideBearing == 0 &&
X					   rightSideBearing == characterWidth &&
X					   ascent == fontAscent &&
X					   descent == fontDescent
X					*/
X    unsigned int	linear:1;	/* true if firstRow == lastRow */
X    unsigned int	constantWidth:1;  /* true if minbounds->metrics.characterWidth
X					   *      == maxbounds->metrics.characterWidth
X					   */
X    unsigned int	inkInside:1;    /* true if for all defined glyphs:
X					 * leftSideBearing >= 0 &&
X					 * rightSideBearing <= characterWidth &&
X					 * -fontDescent <= ascent <= fontAscent &&
X					 * -fontAscent <= descent <= fontDescent
X					 */
X    unsigned int	inkMetrics:1;	/* ink metrics != bitmap metrics */
X					/* used with terminalFont */
X					/* see font's pInk{CI,Min,Max} */
X    unsigned int	padding:28;
X    unsigned int	firstCol;
X    unsigned int	lastCol;
X    unsigned int	firstRow;
X    unsigned int	lastRow;
X    unsigned int	nProps;
X    unsigned int	lenStrings; /* length in bytes of string table */
X    unsigned int	chDefault;  /* default character */ 
X    int			fontDescent; /* minimum for quality typography */
X    int			fontAscent;  /* minimum for quality typography */
X    CharInfoRec		minbounds;  /* MIN of glyph metrics over all chars */
X    CharInfoRec		maxbounds;  /* MAX of glyph metrics over all chars */
X    unsigned int	pixDepth;   /* intensity bits per pixel */
X    unsigned int	glyphSets;  /* number of sets of glyphs, for
X					    sub-pixel positioning */
X    unsigned int	version2;   /* version stamp double-check */
} FontInfoRec;
X
typedef struct _ExtentInfo {
X    DrawDirection	drawDirection;
X    int			fontAscent;
X    int			fontDescent;
X    int			overallAscent;
X    int			overallDescent;
X    int			overallWidth;
X    int			overallLeft;
X    int			overallRight;
} ExtentInfoRec;
X
#endif /* FONTSTRUCT_H */
X
SHAR_EOF
chmod 0664 fontstruct.h ||
echo 'restore of fontstruct.h failed'
Wc_c="`wc -c < 'fontstruct.h'`"
test 3784 -eq "$Wc_c" ||
	echo 'fontstruct.h: original size 3784, current size' "$Wc_c"
fi
# ============= misc.h ==============
if test -f 'misc.h' -a X"$1" != X"-c"; then
	echo 'x - skipping misc.h (File already exists)'
else
echo 'x - extracting misc.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'misc.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
/* $XConsortium: misc.h,v 1.53 89/07/18 13:33:56 rws Exp $ */
#ifndef MISC_H
#define MISC_H 1
/*
X *  X internal definitions 
X *
X */
X
X
extern unsigned long globalSerialNumber;
extern unsigned long serverGeneration;
X
#ifndef NULL
#if __STDC__ && !NOSTDHDRS
#include <stddef.h>
#else
#define NULL            0
#endif
#endif
X
#define MAXSCREENS	3
#define MAXCLIENTS	128
#define MAXFORMATS	8
#define MAXVISUALS_PER_SCREEN 50
X
typedef unsigned char *pointer;
typedef int Bool;
typedef unsigned long PIXEL;
typedef unsigned long ATOM;
X
X
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
#include "os.h" 	/* for ALLOCATE_LOCAL and DEALLOCATE_LOCAL */
X
#define NullBox ((BoxPtr)0)
#define MILLI_PER_MIN (1000 * 60)
#define MILLI_PER_SECOND (1000)
X
X    /* this next is used with None and ParentRelative to tell
X       PaintWin() what to use to paint the background. Also used
X       in the macro IS_VALID_PIXMAP */
X
#define USE_BACKGROUND_PIXEL 3
#define USE_BORDER_PIXEL 3
X
X
/* byte swap a long literal */
#define lswapl(x) ((((x) & 0xff) << 24) |\
X		   (((x) & 0xff00) << 8) |\
X		   (((x) & 0xff0000) >> 8) |\
X		   (((x) >> 24) & 0xff))
X
/* byte swap a short literal */
#define lswaps(x) ((((x) & 0xff) << 8) | (((x) >> 8) & 0xff))
X
#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))
#define abs(a) ((a) > 0 ? (a) : -(a))
#define fabs(a) ((a) > 0.0 ? (a) : -(a))	/* floating absolute value */
#define sign(x) ((x) < 0 ? -1 : ((x) > 0 ? 1 : 0))
/*
X * return the least significant bit in x which is set
X *
X * This works on 1's complement and 2's complement machines.
X * If you care about the extra instruction on 2's complement
X * machines, change to ((x) & (-(x)))
X */
#define lowbit(x) ((x) & (~(x) + 1))
X
#define MAXSHORT 32767
#define MINSHORT -MAXSHORT 
X
X
/* some macros to help swap requests, replies, and events */
X
#define LengthRestB(stuff) \
X    (((unsigned long)stuff->length << 2) - sizeof(*stuff))
X
#define LengthRestS(stuff) \
X    (((unsigned long)stuff->length << 1) - (sizeof(*stuff) >> 1))
X
#define LengthRestL(stuff) \
X    ((unsigned long)stuff->length - (sizeof(*stuff) >> 2))
X
#define SwapRestS(stuff) \
X    SwapShorts((short *)(stuff + 1), LengthRestS(stuff))
X
#define SwapRestL(stuff) \
X    SwapLongs((long *)(stuff + 1), LengthRestL(stuff))
X
/* byte swap a long */
#define swapl(x, n) n = ((char *) (x))[0];\
X		 ((char *) (x))[0] = ((char *) (x))[3];\
X		 ((char *) (x))[3] = n;\
X		 n = ((char *) (x))[1];\
X		 ((char *) (x))[1] = ((char *) (x))[2];\
X		 ((char *) (x))[2] = n;
X
/* byte swap a short */
#define swaps(x, n) n = ((char *) (x))[0];\
X		 ((char *) (x))[0] = ((char *) (x))[1];\
X		 ((char *) (x))[1] = n
X
/* copy long from src to dst byteswapping on the way */
#define cpswapl(src, dst) \
X                 ((char *)&(dst))[0] = ((char *) &(src))[3];\
X                 ((char *)&(dst))[1] = ((char *) &(src))[2];\
X                 ((char *)&(dst))[2] = ((char *) &(src))[1];\
X                 ((char *)&(dst))[3] = ((char *) &(src))[0];
X
/* copy short from src to dst byteswapping on the way */
#define cpswaps(src, dst)\
X		 ((char *) &(dst))[0] = ((char *) &(src))[1];\
X		 ((char *) &(dst))[1] = ((char *) &(src))[0];
X
extern void SwapLongs();
extern void SwapShorts();
X
typedef struct _DDXPoint *DDXPointPtr;
typedef struct _Box *BoxPtr;
X
#endif /* MISC_H */
SHAR_EOF
chmod 0664 misc.h ||
echo 'restore of misc.h failed'
Wc_c="`wc -c < 'misc.h'`"
test 4542 -eq "$Wc_c" ||
	echo 'misc.h: original size 4542, current size' "$Wc_c"
fi
# ============= os.h ==============
if test -f 'os.h' -a X"$1" != X"-c"; then
	echo 'x - skipping os.h (File already exists)'
else
echo 'x - extracting os.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'os.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
X
/* $XConsortium: os.h,v 1.39 89/12/06 16:41:26 rws Exp $ */
X
#ifndef OS_H
#define OS_H
#include "misc.h"
X
#ifdef INCLUDE_ALLOCA_H
#include <alloca.h>
#endif
X
#define NullFID ((FID) 0)
X
#define SCREEN_SAVER_ON   0
#define SCREEN_SAVER_OFF  1
#define SCREEN_SAVER_FORCER 2
X
#if defined(stellar)
#define MAX_REQUEST_SIZE 65535
#else
#define MAX_REQUEST_SIZE 16384
#endif
X
typedef pointer	FID;
typedef struct _FontPathRec *FontPathPtr;
typedef struct _NewClientRec *NewClientPtr;
X
#ifndef NO_ALLOCA
/*
X * os-dependent definition of local allocation and deallocation
X * If you want something other than Xalloc/Xfree for ALLOCATE/DEALLOCATE
X * LOCAL then you add that in here.
X */
#if defined(__HIGHC__)
X
extern char *alloca();
X
#if HCVERSION < 21003
#define ALLOCATE_LOCAL(size)	alloca((int)(size))
pragma on(alloca);
#else /* HCVERSION >= 21003 */
#define	ALLOCATE_LOCAL(size)	_Alloca((int)(size))
#endif /* HCVERSION < 21003 */
X
#define DEALLOCATE_LOCAL(ptr)  /* as nothing */
X
#endif /* defined(__HIGHC__) */
X
X
#ifdef __GNUC__
#define alloca __builtin_alloca
#define ALLOCATE_LOCAL(size) alloca((int)(size))
#define DEALLOCATE_LOCAL(ptr)  /* as nothing */
#else /* ! __GNUC__ */
/*
X * warning: mips alloca is unsuitable in the server, do not use.
X */
#if defined(vax) || defined(sun) || defined(apollo) || defined(stellar)
/*
X * Some System V boxes extract alloca.o from /lib/libPW.a; if you
X * decide that you don't want to use alloca, you might want to fix 
X * ../os/4.2bsd/Imakefile
X */
char *alloca();
#define ALLOCATE_LOCAL(size) alloca((int)(size))
#define DEALLOCATE_LOCAL(ptr)  /* as nothing */
#endif /* who does alloca */
#endif /* __GNUC__ */
X
#endif /* NO_ALLOCA */
X
#ifndef ALLOCATE_LOCAL
#define ALLOCATE_LOCAL(size) Xalloc((unsigned long)(size))
#define DEALLOCATE_LOCAL(ptr) Xfree((pointer)(ptr))
#endif /* ALLOCATE_LOCAL */
X
X
#define xalloc(size) Xalloc((unsigned long)(size))
#define xrealloc(ptr, size) Xrealloc((pointer)(ptr), (unsigned long)(size))
#define xfree(ptr) Xfree((pointer)(ptr))
X
int		ReadRequestFromClient();
char		*strcat();
char		*strncat();
char		*strcpy();
char		*strncpy();
Bool		CloseDownConnection();
FontPathPtr	GetFontPath();
FontPathPtr	ExpandFontNamePattern();
FID		FiOpenForRead();
void		CreateWellKnownSockets();
int		SetDefaultFontPath();
void		FreeFontRecord();
int		SetFontPath();
void		ErrorF();
void		Error();
void		FatalError();
void		ProcessCommandLine();
void		Xfree();
void		FlushAllOutput();
void		FlushIfCriticalOutputPending();
unsigned long	*Xalloc();
unsigned long	*Xrealloc();
long		GetTimeInMillis();
X
#endif /* OS_H */
SHAR_EOF
chmod 0664 os.h ||
echo 'restore of os.h failed'
Wc_c="`wc -c < 'os.h'`"
test 3804 -eq "$Wc_c" ||
	echo 'os.h: original size 3804, current size' "$Wc_c"
fi
# ============= servermd.h ==============
if test -f 'servermd.h' -a X"$1" != X"-c"; then
	echo 'x - skipping servermd.h (File already exists)'
else
echo 'x - extracting servermd.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'servermd.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
#ifndef SERVERMD_H
#define SERVERMD_H 1
/* $XConsortium: servermd.h,v 1.48 89/12/06 16:56:14 rws Exp $ */
X
/*
X * The vendor string identifies the vendor responsible for the
X * server executable.
X */
#ifndef VENDOR_STRING
#define VENDOR_STRING "MIT X Consortium"
#endif
X
/*
X * The vendor release number identifies, for the purpose of submitting
X * traceable bug reports, the release number of software produced
X * by the vendor.
X */
#ifndef VENDOR_RELEASE
#define VENDOR_RELEASE	4
#endif
X
/*
X * Machine dependent values:
X * GLYPHPADBYTES should be chosen with consideration for the space-time
X * trade-off.  Padding to 0 bytes means that there is no wasted space
X * in the font bitmaps (both on disk and in memory), but that access of
X * the bitmaps will cause odd-address memory references.  Padding to
X * 2 bytes would ensure even address memory references and would
X * be suitable for a 68010-class machine, but at the expense of wasted
X * space in the font bitmaps.  Padding to 4 bytes would be good
X * for real 32 bit machines, etc.  Be sure that you tell the font
X * compiler what kind of padding you want because its defines are
X * kept separate from this.  See server/include/font.h for how
X * GLYPHPADBYTES is used.
X *
X * Along with this, you should choose an appropriate value for
X * GETLEFTBITS_ALIGNMENT, which is used in ddx/mfb/maskbits.h.  This
X * constant choses what kind of memory references are guarenteed during
X * font access; either 1, 2 or 4, for byte, word or longword access,
X * respectively.  For instance, if you have decided to to have
X * GLYPHPADBYTES == 4, then it is pointless for you to have a
X * GETLEFTBITS_ALIGNMENT > 1, because the padding of the fonts has already
X * guarenteed you that your fonts are longword aligned.  On the other
X * hand, even if you have chosen GLYPHPADBYTES == 1 to save space, you may
X * also decide that the computing involved in aligning the pointer is more
X * costly than an odd-address access; you choose GETLEFTBITS_ALIGNMENT == 1.
X *
X * Next, choose the tuning parameters which are appropriate for your
X * hardware; these modify the behaviour of the raw frame buffer code
X * in ddx/mfb and ddx/cfb.  Defining these incorrectly will not cause
X * the server to run incorrectly, but defining these correctly will
X * cause some noticeable speed improvements:
X *
X *  AVOID_MEMORY_READ - (8-bit cfb only)
X *	When stippling pixels on the screen (polytext and pushpixels),
X *	don't read long words from the display and mask in the
X *	appropriate values.  Rather, perform multiple byte/short/long
X *	writes as appropriate.  This option uses many more instructions
X *	but runs much faster when the destination is much slower than
X *	the CPU and at least 1 level of write buffer is availible (2
X *	is much better).  Defined currently for SPARC and MIPS.
X *
X *  FAST_CONSTANT_OFFSET_MODE - (cfb and mfb)
X *	This define is used on machines which have no auto-increment
X *	addressing mode, but do have an effectively free constant-offset
X *	addressing mode.  Only MIPS uses this currently.
X *	
X *  LARGE_INSTRUCTION_CACHE -
X *	This define increases the number of times some loops are
X *	unrolled.  On 68020 machines (with 256 bytes of i-cache),
X *	this define will slow execution down as instructions miss
X *	the cache frequently.  On machines with real i-caches, this
X *	reduces loop overhead, causing a slight performance improvement.
X *	Currently defined for MIPS and SPARC
X */
X
#ifdef vax
X
#define IMAGE_BYTE_ORDER	LSBFirst        /* Values for the VAX only */
#define BITMAP_BIT_ORDER	LSBFirst
#define	GLYPHPADBYTES		1
#define GETLEFTBITS_ALIGNMENT	4
X
#endif /* vax */
X
#ifdef sun
X
#if defined(sun386) || defined(sun5)
# define IMAGE_BYTE_ORDER	LSBFirst        /* Values for the SUN only */
# define BITMAP_BIT_ORDER	LSBFirst
#else
# define IMAGE_BYTE_ORDER	MSBFirst        /* Values for the SUN only */
# define BITMAP_BIT_ORDER	MSBFirst
#endif
X
#ifdef sparc
# define AVOID_MEMORY_READ
# define LARGE_INSTRUCTION_CACHE
#endif
X
#define	GLYPHPADBYTES		4
#define GETLEFTBITS_ALIGNMENT	1
X
#endif /* sun */
X
#ifdef apollo
X
#define IMAGE_BYTE_ORDER	MSBFirst        /* Values for the Apollo only*/
#define BITMAP_BIT_ORDER	MSBFirst
#define	GLYPHPADBYTES		2
#define GETLEFTBITS_ALIGNMENT	4
X
#endif /* apollo */
X
#if defined(ibm032) || defined (ibm)
X
#ifdef i386
# define IMAGE_BYTE_ORDER	LSBFirst	/* Value for PS/2 only */
#else
# define IMAGE_BYTE_ORDER	MSBFirst        /* Values for the RT only*/
#endif
#define BITMAP_BIT_ORDER	MSBFirst
#define	GLYPHPADBYTES		1
#define GETLEFTBITS_ALIGNMENT	4
/* ibm pcc doesn't understand pragmas. */
X
#endif /* ibm */
X
#ifdef hpux
X
#define IMAGE_BYTE_ORDER	MSBFirst        /* Values for the HP only */
#define BITMAP_BIT_ORDER	MSBFirst
#define	GLYPHPADBYTES		4
#define	GETLEFTBITS_ALIGNMENT	1
X
#endif /* hpux */
X
#if defined(M4315) || defined(M4317) || defined(M4319) || defined(M4330)
X
#define IMAGE_BYTE_ORDER	MSBFirst        /* Values for Pegasus only */
#define BITMAP_BIT_ORDER	MSBFirst
#define GLYPHPADBYTES		4
#define GETLEFTBITS_ALIGNMENT	1
X
#endif /* tektronix */
X
#ifdef macII
X
#define IMAGE_BYTE_ORDER      	MSBFirst        /* Values for the MacII only */
#define BITMAP_BIT_ORDER      	MSBFirst
#define GLYPHPADBYTES         	4
#define GETLEFTBITS_ALIGNMENT 	1
X
#endif /* macII */
X
#ifdef mips
X
#ifdef MIPSEL
# define IMAGE_BYTE_ORDER	LSBFirst        /* Values for the PMAX only */
# define BITMAP_BIT_ORDER	LSBFirst
# define GLYPHPADBYTES		4
# define GETLEFTBITS_ALIGNMENT	1
#else
# define IMAGE_BYTE_ORDER	MSBFirst        /* Values for the MIPS only */
# define BITMAP_BIT_ORDER	MSBFirst
# define GLYPHPADBYTES		4
# define GETLEFTBITS_ALIGNMENT	1
#endif
X
#define AVOID_MEMORY_READ
#define FAST_CONSTANT_OFFSET_MODE
#define LARGE_INSTRUCTION_CACHE
X
#endif /* mips */
X
#ifdef stellar
X
#define IMAGE_BYTE_ORDER	MSBFirst       /* Values for the stellar only*/
#define BITMAP_BIT_ORDER	MSBFirst
#define	GLYPHPADBYTES		4
#define GETLEFTBITS_ALIGNMENT	4
/*
X * Use SysV random number generator.
X */
#define random rand
X
#endif /* stellar */
X
/* size of buffer to use with GetImage, measured in bytes. There's obviously
X * a trade-off between the amount of stack (or whatever ALLOCATE_LOCAL gives
X * you) used and the number of times the ddx routine has to be called.
X * 
X * for a 1024 x 864 bit monochrome screen  with a 32 bit word we get 
X * 8192/4 words per buffer 
X * (1024/32) = 32 words per scanline
X * 2048 words per buffer / 32 words per scanline = 64 scanlines per buffer
X * 864 scanlines / 64 scanlines = 14 buffers to draw a full screen
X */
#if defined(stellar)
#define IMAGE_BUFSIZE		(64*1024)
#else
#define IMAGE_BUFSIZE		8192
#endif
X
/* pad scanline to a longword */
#if defined(ibm) && defined(i386)
#define BITMAP_SCANLINE_UNIT	8
#else
#define BITMAP_SCANLINE_UNIT	32
#endif
#define BITMAP_SCANLINE_PAD  32
X
#define LOG2_BITMAP_PAD		5
#define LOG2_BYTES_PER_SCANLINE_PAD	2
X
/* 
X *   This returns the number of padding units, for depth d and width w.
X * For bitmaps this can be calculated with the macros above.
X * Other depths require either grovelling over the formats field of the
X * screenInfo or hardwired constants.
X */
X
typedef struct _PaddingInfo {
X	int     padRoundUp;	/* pixels per pad unit - 1 */
X	int	padPixelsLog2;	/* log 2 (pixels per pad unit) */
X	int     padBytesLog2;	/* log 2 (bytes per pad unit) */
} PaddingInfo;
extern PaddingInfo PixmapWidthPaddingInfo[];
X
#define PixmapWidthInPadUnits(w, d) \
X    (((w) + PixmapWidthPaddingInfo[d].padRoundUp) >> \
X	PixmapWidthPaddingInfo[d].padPixelsLog2)
X
/*
X *	Return the number of bytes to which a scanline of the given
X * depth and width will be padded.
X */
#define PixmapBytePad(w, d) \
X    (PixmapWidthInPadUnits(w, d) << PixmapWidthPaddingInfo[d].padBytesLog2)
X
#endif /* SERVERMD_H */
SHAR_EOF
chmod 0664 servermd.h ||
echo 'restore of servermd.h failed'
Wc_c="`wc -c < 'servermd.h'`"
test 8984 -eq "$Wc_c" ||
	echo 'servermd.h: original size 8984, current size' "$Wc_c"
fi
# ============= snfstruct.h ==============
if test -f 'snfstruct.h' -a X"$1" != X"-c"; then
	echo 'x - skipping snfstruct.h (File already exists)'
else
echo 'x - extracting snfstruct.h (Text)'
sed 's/^X//' << 'SHAR_EOF' > 'snfstruct.h' &&
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
X
X                        All Rights Reserved
X
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  
X
DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
X
******************************************************************/
#ifndef SNFSTRUCT_H
#define SNFSTRUCT_H 1
#include "font.h"
#include "misc.h"
X
/*
X * This file describes the Server Natural Font format.
X * SNF fonts are both CPU-dependent and frame buffer bit order dependent.
X * This file is used by:
X *	1)  the server, to hold font information read out of font files.
X *	2)  font converters
X *
X * Each font file contains the following
X * data structures, with no padding in-between.
X *
X *	1)  The XFONTINFO structure
X *		hand-padded to a two-short boundary.
X *		maxbounds.byteoffset is the total number of bytes in the
X *			glpyh array
X *		maxbounds.bitOffset is thetotal width of the unpadded font
X *
X *	2)  The XCHARINFO array
X *		indexed directly with character codes, both on disk
X *		and in memory.
X *
X *	3)  Character glyphs
X *		padded in the server-natural way, and
X *		ordered in the device-natural way.
X *		End of glyphs padded to 32-bit boundary.
X *
X *	4)  nProps font properties
X *
X *	5)  a sequence of null-terminated strings, for font properties
X */
X
#define FONT_FILE_VERSION	4
X
typedef struct _FontProp { 
X	CARD32	name;		/* offset of string */
X	INT32	value;		/* number or offset of string */
X	Bool	indirect;	/* value is a string offset */
} FontPropRec;
X
/*
X * the following macro definitions describe a font file image in memory
X */
#define ADDRCharInfoRec( pfi)	\
X	((CharInfoRec *) &(pfi)[1])
X
#define ADDRCHARGLYPHS( pfi)	\
X	(((char *) &(pfi)[1]) + BYTESOFCHARINFO(pfi))
X
/*
X * pad out glyphs to a CARD32 boundary
X */
#define ADDRXFONTPROPS( pfi)  \
X	((DIXFontProp *) ((char *)ADDRCHARGLYPHS( pfi) + BYTESOFGLYPHINFO(pfi)))
X
#define ADDRSTRINGTAB( pfi)  \
X	((char *)ADDRXFONTPROPS( pfi) + BYTESOFPROPINFO(pfi))
X
#define	BYTESOFFONTINFO(pfi)	(sizeof(FontInfoRec))
#define BYTESOFCHARINFO(pfi)	(sizeof(CharInfoRec) * n2dChars(pfi))
#define	BYTESOFPROPINFO(pfi)	(sizeof(FontPropRec) * (pfi)->nProps)
#define	BYTESOFSTRINGINFO(pfi)	((pfi)->lenStrings)
#define	BYTESOFGLYPHINFO(pfi)	(((pfi)->maxbounds.byteOffset+3) & ~0x3)
#define BYTESOFINKINFO(pfi)	(sizeof(CharInfoRec) * (2 + n2dChars(pfi)))
X 
#endif /* SNFSTRUCT_H */
X
SHAR_EOF
chmod 0664 snfstruct.h ||
echo 'restore of snfstruct.h failed'
Wc_c="`wc -c < 'snfstruct.h'`"
test 3296 -eq "$Wc_c" ||
	echo 'snfstruct.h: original size 3296, current size' "$Wc_c"
fi
exit 0
